using C1.Win.FlexGrid;

namespace FlexNodeExpanded
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();

      this.c1FlexGrid1.Rows.Count = 1;
      this.c1FlexGrid1.Cols.Count = 1;
      this.c1FlexGrid1.Cols.Fixed = 0;
      this.c1FlexGrid1.Cols[0].StarWidth = "*";

      this.c1FlexGrid1.Tree.Column = 0;
      //this.c1FlexGrid1.Tree.Style = C1.Win.FlexGrid.TreeStyleFlags.
      this.c1FlexGrid1.BeginUpdate();


      this.InsertGridNode("Termin-Details", 0);
      this.InsertGridLine("Kurzzeichen:");
      this.InsertGridLine("Produktionsalternative:");
      this.InsertGridLine("Raum:");
      this.InsertGridLine("Markierung:");
      this.InsertGridLine("VA-Typ:");
      this.InsertGridLine("Beginn/Ende:");
      this.InsertGridLine("%projektterminart_Si%:");
      this.InsertGridLine("Eigentmer:");
      this.InsertGridLine("Abteilung:");
      this.InsertGridLine("Varianten:");
      this.InsertGridLine("Dispo extern:");
      this.InsertGridLine("Tagesplan:");
      this.InsertGridLine("Dispo intern:");
      this.InsertGridLine("Kostentrger:");
      this.InsertGridLine("Status:");
      this.InsertGridNode("Titel/Quelle/Rechte", 1);
      this.InsertGridLine("bertitel:");
      this.InsertGridLine("Untertitel:");
      this.InsertGridLine("Zusatz 1:");
      this.InsertGridLine("Zusatz 2:");
      this.InsertGridLine("Pressetitel:");
      this.InsertGridLine("Sprache:");
      this.InsertGridLine("Sprachbeschreibung:");
      this.InsertGridLine("Produktionstyp:");
      this.InsertGridLine("Veranstalter:");
      this.InsertGridLine("Koproduktionspartner:");
      this.InsertGridLine("Rechte:");
      this.c1FlexGrid1.Rows[17].Node.Expanded = false;
      this.InsertGridNode("Verkaufsinformationen", 1);
      this.InsertGridLine("Vk-URL:");
      this.InsertGridLine("Preise:");
      this.InsertGridLine("Verkaufseinschrnkungen:");
      this.InsertGridLine("Vorverkauf ab:");
      this.InsertGridLine("Besucheranzahl:");
      this.InsertGridLine("Preisinfo:");
      this.InsertGridLine("Sperrungen/Ticketinfo:");
      this.InsertGridLine("Kartenstand");
      this.InsertGridLine("Datum des Kartenstand");
      this.InsertGridLine("Abonnements:");
      bool invisible1;
      this.c1FlexGrid1.Rows[29].Node.Expanded = false;
      this.InsertGridNode("Zeitabschnitte", 1);
      this.InsertGridLine("Knstl. Zeitabschnitte:");
      bool invisible2;
      this.c1FlexGrid1.Rows[40].Node.Expanded = false;
      this.InsertGridNode("Tantiemenverwaltung", 1);
      this.InsertGridLine("Einnahmen freier Verkauf");
      this.InsertGridLine("Einnahmen Abonnement");
      this.InsertGridLine("AVA:");
      this.InsertGridLine("AVA abgerechnet:");
      this.InsertGridLine("Tantiemenvertrge:");
      this.InsertGridLine("Anzahl Preisgruppen:");
      this.InsertGridLine("Nettokapazitt d. Raums:");
      this.InsertGridLine("Kartenverkufe:");
      this.InsertGridNode("Technikdaten", 1);
      this.InsertGridLine("Techn. Zeitabschnitte:");
      this.InsertGridLine("Terminablauf:");
      this.InsertGridLine("Notiz \"Abfahrtszeiten\":");
      this.InsertGridLine("Notiz \"Reiseinformationen\":");
      this.InsertGridNode("Dateien", 1);
      this.InsertGridLine("Bhnenplne [Dokument]");
      this.InsertGridLine("Bhnenplne [Dokument]");
      this.InsertGridLine("Bhnenplne [Dokument]");
      this.InsertGridNode("Abonnements", 0);
      this.InsertGridLine("");
      this.InsertGridNode("Besetzungen", 0);
      this.InsertGridNode("Veranstaltungsdienst", 1);
      this.InsertGridLine("");
      this.InsertGridNode("Kollektive", 0);
      this.InsertGridLine("");
      this.InsertGridNode("Artikel", 0);
      this.InsertGridLine("");


      //Workaround: set "expanded" after filling:
      //this.c1FlexGrid1.Rows[17].Node.Expanded = false;
      //this.c1FlexGrid1.Rows[29].Node.Expanded = false;
      //this.c1FlexGrid1.Rows[40].Node.Expanded = false;

      this.c1FlexGrid1.EndUpdate();
    }

    /// <summary>
    /// In Grid (Tree) einen Header-Knoten einfgen.
    /// </summary>
    /// <param name="_strHeader">berschrifttext. Darf Platzhalter erhalten.</param>
    /// <param name="_intLevel">Level des neu einzufgenden Knoten.</param>
    /// <returns>Index der zugefgten Zeile</returns>
    private int InsertGridNode(string _strHeader, int _intLevel)
    {
      this.c1FlexGrid1.Rows.Add();
      int intRow = this.c1FlexGrid1.Rows.Count - 1;
      this.c1FlexGrid1.SetData(intRow, 0, _strHeader);
      this.c1FlexGrid1.Rows[intRow].IsNode = true;
      this.c1FlexGrid1.Rows[intRow].Node.Level = _intLevel;
      
      return intRow;
    }

    /// <summary>
    /// In Grid (Tree) einen Satz einfgen.
    /// </summary>
    /// <param name="_strHeader">berschrifttext. Darf Platzhalter erhalten.</param>
    /// <param name="_strValue"></param>
    /// <param name="_bolHasRechtRead">TRUE: Feld ist berechtigt. FALSE: nicht berechtigt (dann wird statt des Werts ein Platzhalter ausgegeben)</param>
    /// <returns>Index der neu zugefgten Zeile</returns>
    private int InsertGridLine(string _strHeader)
    {
      Row rowNew = this.c1FlexGrid1.Rows.Add();
      int intRow = rowNew.Index;
      
      this.c1FlexGrid1.SetData(intRow, 0, _strHeader);
      
      return intRow;
    }
  }
}
